// SS_232C_RLSW_VC2005_SAMPLEDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SS_232C_RLSW_VC2005_SAMPLE.h"
#include "SS_232C_RLSW_VC2005_SAMPLEDlg.h"
#include "ss232crlsw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//--------------------------------------------------------------------------------
//[萔`]
//--------------------------------------------------------------------------------
#define INI_FILE				".\\SS232CRLSW_sample.ini"		//ݒt@C
#define DEFAULT_COM				"COM1"							//COM1
#define DEFAULT_ID				(0xFF)							//ff
#define DEFAULT_BAUDRATE		(9600)							//9600bps
#define DEFAULT_BYTE_SIZE		(8)								//8bit
#define DEFAULT_PARITY			PARITY_None						//peB
#define DEFAULT_STOPBIT			STOP_Bit1						//1bit
//--------------------------------------------------------------------------------
//[GA`]
//--------------------------------------------------------------------------------
bool gIsConnect = false;										//ڑԋLp
short gOutput = 0;												//ݏoIO
char gCom[32];													//COM|[g
char gId = (char)DEFAULT_ID;                                    //R}hID
int gBaudrate = DEFAULT_BAUDRATE;                               //{[[g
char gByteSize = DEFAULT_BYTE_SIZE;                             //oCg
char gParity = DEFAULT_PARITY;                                  //peB
char gStopBit = DEFAULT_STOPBIT;                                //Xgbvrbg
/////////////////////////////////////////////////////////////////////////////
// CSS_232C_RLSW_VC6_SAMPLEDlg _CAO

CSS_232C_RLSW_VC6_SAMPLEDlg::CSS_232C_RLSW_VC6_SAMPLEDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSS_232C_RLSW_VC6_SAMPLEDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSS_232C_RLSW_VC6_SAMPLEDlg)
	m_rdoLength = -1;
	m_rdoParity = -1;
	m_rdoStop = -1;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSS_232C_RLSW_VC6_SAMPLEDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSS_232C_RLSW_VC6_SAMPLEDlg)
	DDX_Control(pDX, IDC_EDIT_ID, m_txtId);
	DDX_Control(pDX, IDC_COMBO_SPEED, m_cboSpeed);
	DDX_Control(pDX, IDC_COMBO_COM, m_cboCom);
	DDX_Radio(pDX, IDC_RADIO_LEN8, m_rdoLength);
	DDX_Radio(pDX, IDC_RADIO_PARITY_NONE, m_rdoParity);
	DDX_Radio(pDX, IDC_RADIO_STOP1, m_rdoStop);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSS_232C_RLSW_VC6_SAMPLEDlg, CDialog)
	//{{AFX_MSG_MAP(CSS_232C_RLSW_VC6_SAMPLEDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN_CLOSE, OnButtonOpenClose)
	ON_BN_CLICKED(IDC_BUTTON_CH1, OnButtonCh1)
	ON_BN_CLICKED(IDC_BUTTON_CH2, OnButtonCh2)
	ON_BN_CLICKED(IDC_BUTTON_CH3, OnButtonCh3)
	ON_BN_CLICKED(IDC_BUTTON_CH4, OnButtonCh4)
	ON_BN_CLICKED(IDC_BUTTON_CH5, OnButtonCh5)
	ON_BN_CLICKED(IDC_BUTTON_CH6, OnButtonCh6)
	ON_BN_CLICKED(IDC_BUTTON_CH7, OnButtonCh7)
	ON_BN_CLICKED(IDC_BUTTON_CH8, OnButtonCh8)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSS_232C_RLSW_VC6_SAMPLEDlg bZ[W nh

BOOL CSS_232C_RLSW_VC6_SAMPLEDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	m_cboCom.AddString("COM1");
	m_cboCom.AddString("COM2");
	m_cboCom.AddString("COM3");
	m_cboCom.AddString("COM4");
	m_txtId.LimitText(2);
	m_cboSpeed.AddString("4800");
	m_cboSpeed.AddString("9600");
	m_cboSpeed.AddString("19200");
	m_cboSpeed.AddString("38400");

    vfnReadIniFile();				//ݒt@C̓ǂݍ
    vfnValueToControl();			//p[^Rg[ɔf
    gIsConnect = false;             //ؒf
    vfnControlsLock(false);			//ؒfԂ̃Rg[ݒ
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CSS_232C_RLSW_VC6_SAMPLEDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSS_232C_RLSW_VC6_SAMPLEDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//--------------------------------------------------------------------------------
//[Evnt]ڑ/ؒf{^
//[]COM|[g̐ڑ/ؒfs܂B
//      ڑAݒݒt@CɋL܂B
//      ڑAo͏ԂeCh̃{^ɕ\܂B
//		ڑAfoCX̏\܂B
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonOpenClose() 
{
	int iRet;
	CString name;
	CButton *btn = (CButton*)GetDlgItem(IDC_BUTTON_OPEN_CLOSE);
	
	btn->EnableWindow(false);
	btn->GetWindowText(name);

    if(name == "Open")
	{
        if(bfnCheckControl())
		{
            vfnControlToValue();					//p[^XV
		    vfnValueToControl();					//Rg[f
            iRet = SS232CRLSW_open(gCom, gBaudrate, gByteSize, gParity, gStopBit);
            if(iRet != RET_OK)
			{
				vfnDllCallError("SS232CRLSW_open",iRet);
			}
            else
			{
                vfnWriteIniFile();                  //p[^ۑ
				btn->SetWindowText("Close");		//Close{^ɕύX
                vfnControlsLock(true);				//gp\Rg[؂ւ
                vfnReadOutput();					//eCh̃{^ɏo͏Ԃ\
				vfnReadDeviceInfo();				//foCX̕\
                gIsConnect = true;					//ڑL
			}
		}
	}
	else
	{
        SS232CRLSW_close();							//ؒf
		btn->SetWindowText("Open");					//Open{^ɕύX
        vfnControlsLock(false);						//gp\Rg[̐؂ւ
        gIsConnect = false;							//ؒfL
    }
	btn->EnableWindow(true);
}
//--------------------------------------------------------------------------------
//[Evnt]tH[A[h
//[]ڑς݂Ȃؒfs
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnClose() 
{
    if(gIsConnect)
	{
        SS232CRLSW_close();
	}
	CDialog::OnClose();
}
//--------------------------------------------------------------------------------
//[Evnt]Ch.Set/Reset{^
//[]eChɏo͐ݒ(ON/OFF)s܂B
//      ݒo͏ԂQƂ܂B
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh1() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 0));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh2() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 1));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh3() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 2));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh4() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 3));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh5() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 4));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh6() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 5));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh7() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 6));
}
void CSS_232C_RLSW_VC6_SAMPLEDlg::OnButtonCh8() 
{
	vfnOutput((short)gOutput ^ (short)(0x1 << 7));
}
//--------------------------------------------------------------------------------
//[֐]o͐ݒ
//[]o͐ݒs܂B
//[]data	o̓rbg
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnOutput(short data)
{
    int iRet = SS232CRLSW_output_data(gId, data);
    if (iRet == RET_OK)
	{
        vfnReadOutput();    //o͎Q
	}
	else
	{
		vfnDllCallError("SS232CRLSW_output_data",iRet);
    }
}
//--------------------------------------------------------------------------------
//[֐]Rg[̏Ԑݒ
//[](ڑ^ؒf)ɍ킹ĎgpoRg[ݒ肵܂B
//[]connect  true:ڑԁAfalse:ؒf
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnControlsLock(bool connect)
{
	//ڑgp\
	(CButton*)GetDlgItem(IDC_BUTTON_CH1)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH2)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH3)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH4)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH5)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH6)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH7)->EnableWindow(connect);
	(CButton*)GetDlgItem(IDC_BUTTON_CH8)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH1)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH2)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH3)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH4)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH5)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH6)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH7)->EnableWindow(connect);
	(CStatic*)GetDlgItem(IDC_STATIC_CH8)->EnableWindow(connect);
	((CButton*)GetDlgItem(IDC_BUTTON_CH1))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH2))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH3))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH4))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH5))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH6))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH7))->SetWindowText("");
	((CButton*)GetDlgItem(IDC_BUTTON_CH8))->SetWindowText("");
	//ڑgp֎~
	(CStatic*)GetDlgItem(IDC_STATIC_DEVICE)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_PORT)->EnableWindow(!connect);
	(CComboBox*)GetDlgItem(IDC_COMBO_COM)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_ID)->EnableWindow(!connect);
	(CEdit*)GetDlgItem(IDC_EDIT_ID)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_HEX)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_SETTING)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_SPEED)->EnableWindow(!connect);
	(CComboBox*)GetDlgItem(IDC_COMBO_SPEED)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_BPS)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_LENGTH)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_LEN8)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_LEN7)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_PARITY)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_PARITY_NONE)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_PARITY_ODD)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_PARITY_EVEN)->EnableWindow(!connect);
	(CStatic*)GetDlgItem(IDC_STATIC_STOP)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_STOP1)->EnableWindow(!connect);
	(CButton*)GetDlgItem(IDC_RADIO_STOP2)->EnableWindow(!connect);
}
//--------------------------------------------------------------------------------
//[֐]foCX̓ǂݍ
//[]jbgIDƃo[WbZ[W\܂B
//[]Ȃ
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnReadDeviceInfo()
{
    char id = 0;
    int iRet;
	char txt[128];
	char *version;

    iRet = SS232CRLSW_unit_number(&id);
    if (iRet != RET_OK)
    {
		vfnDllCallError("SS232CRLSW_unit_number",iRet);
        return;
    }
    iRet = SS232CRLSW_get_version_number(gId, NULL, 0);
    if (iRet < 0)
    {
		vfnDllCallError("SS232CRLSW_get_version_number",iRet);
        return;
    }
    version = new char[iRet];
    iRet = SS232CRLSW_get_version_number(gId, version, iRet);
    if (iRet < 0)
    {
		vfnDllCallError("SS232CRLSW_get_version_number",iRet);
        return;
    }
	sprintf_s(txt,sizeof(txt),"Unit:[%02X]\r\n%s",(0x000000FF & id),version);
	MessageBox(txt,"foCX",MB_ICONINFORMATION);
}
//--------------------------------------------------------------------------------
//[֐]o͏Ԃ̓ǂݍ
//[]o͏ԂQƂAeCh{^ɕ\܂B
//[]Ȃ
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnReadOutput()
{
	short sOut = 0;
	short sPtn = 0;
	int iRet;
	CString stStatus;

    iRet = SS232CRLSW_read_output_data(gId, &sOut); //o͏ԎQ
    if(iRet == RET_OK)
	{
        gOutput = sOut;                             //o͏ԋL
        //eCh{^ɕ\
        sPtn = 0x1;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH1))->SetWindowText(stStatus);
        sPtn = 0x2;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH2))->SetWindowText(stStatus);
        sPtn = 0x4;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH3))->SetWindowText(stStatus);
        sPtn = 0x8;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH4))->SetWindowText(stStatus);
        sPtn = 0x10;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH5))->SetWindowText(stStatus);
        sPtn = 0x20;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH6))->SetWindowText(stStatus);
        sPtn = 0x40;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH7))->SetWindowText(stStatus);
        sPtn = 0x80;
		stStatus = ((gOutput & sPtn) != 0) ? "" : "";
		((CButton*)GetDlgItem(IDC_BUTTON_CH8))->SetWindowText(stStatus);
	}
	else
	{
		vfnDllCallError("SS232CRLSW_read_gOutput_data",iRet);
	}
}
//--------------------------------------------------------------------------------
//[֐]ݒt@C̓ǂݍ
//[]ݒt@Cp[^ǂݍ݂܂B
//      ǂݍݎs̎͋Kl܂B
//[]Ȃ
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnReadIniFile()
{
	char buf[32];
	char tmp[32];
	unsigned long size;
    
    size = GetPrivateProfileString("DEVICE", "COM", DEFAULT_COM, buf, 16, INI_FILE);
	strcpy_s(gCom,sizeof(gCom),buf);
	sprintf_s(tmp,sizeof(tmp),"%d",DEFAULT_ID);
    size = GetPrivateProfileString("DEVICE", "ID", tmp, buf, 16, INI_FILE);
	gId = (char)atoi(buf);
	sprintf_s(tmp,sizeof(tmp),"%d",DEFAULT_BAUDRATE);
    size = GetPrivateProfileString("SETTING", "BAUDRATE", tmp, buf, 16, INI_FILE);
    gBaudrate = (int)atoi(buf);
	sprintf_s(tmp,sizeof(tmp),"%d",DEFAULT_BYTE_SIZE);
    size = GetPrivateProfileString("SETTING", "BYTE_SIZE", tmp, buf, 16, INI_FILE);
    gByteSize = (char)atoi(buf);
	sprintf_s(tmp,sizeof(tmp),"%d",DEFAULT_PARITY);
    size = GetPrivateProfileString("SETTING", "PARITY", tmp, buf, 16, INI_FILE);
    gParity = (char)atoi(buf);
	sprintf_s(tmp,sizeof(tmp),"%d",DEFAULT_STOPBIT);
    size = GetPrivateProfileString("SETTING", "STOP_BIT", tmp, buf, 16, INI_FILE);
    gStopBit = (char)atoi(buf);
}
//--------------------------------------------------------------------------------
//[֐]ݒt@C̏
//[]ݒt@CɃp[^݂܂B
//[]Ȃ
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnWriteIniFile()
{
	char tmp[32];

    WritePrivateProfileString("DEVICE", "COM", gCom, INI_FILE);
	sprintf_s(tmp,sizeof(tmp),"%d",gId);
    WritePrivateProfileString("DEVICE", "ID", tmp, INI_FILE);
	sprintf_s(tmp,sizeof(tmp),"%d",gBaudrate);
    WritePrivateProfileString("SETTING", "BAUDRATE", tmp, INI_FILE);
	sprintf_s(tmp,sizeof(tmp),"%d",gByteSize);
    WritePrivateProfileString("SETTING", "BYTE_SIZE", tmp, INI_FILE);
	sprintf_s(tmp,sizeof(tmp),"%d",gParity);
    WritePrivateProfileString("SETTING", "PARITY", tmp, INI_FILE);
	sprintf_s(tmp,sizeof(tmp),"%d",gStopBit);
    WritePrivateProfileString("SETTING", "STOP_BIT", tmp, INI_FILE);
}    
//--------------------------------------------------------------------------------
//[֐]p[^̏ԂRg[ɔf
//[]p[^̏ԂΉRg[ɔf
//[]Ȃ
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnValueToControl()
{
	int index;
	char tmp[32];
    
	//COMR{{bNX
	index =  m_cboCom.FindString(-1,gCom);
	if(index == -1) index = 0;
	m_cboCom.SetCurSel(index);
    //IDeLXg{bNX
	sprintf_s(tmp,sizeof(tmp),"%02X",(0x000000FF & gId));
    m_txtId.SetWindowText(tmp);
    //ʐMxR{{bNX
	sprintf_s(tmp,sizeof(tmp),"%d",gBaudrate);
	index =  m_cboSpeed.FindString(-1,tmp);
	if(index == -1) index = 0;
	m_cboSpeed.SetCurSel(index);
    //oCgWI{^
LABEL_BYTE_SIZE:
    switch (gByteSize)
	{
        case 8:m_rdoLength = 0;break;
		case 7:m_rdoLength = 1;break;
		default:
            gByteSize = DEFAULT_BYTE_SIZE;
            goto LABEL_BYTE_SIZE;
	}
    //peBWI{^
LABEL_PARITY:
    switch (gParity)
	{
		case PARITY_None:m_rdoParity = 0;break;
		case PARITY_Odd:m_rdoParity = 1;break;
		case PARITY_Even:m_rdoParity = 2;break;
		default:
			gParity = DEFAULT_PARITY;
			goto LABEL_PARITY;
	}
    //XgbvrbgWI{^
LABEL_STOP_BIT:
    switch (gStopBit)
	{
		case STOP_Bit1:m_rdoStop = 0;break;
		case STOP_Bit2:m_rdoStop = 0;break;
		default:
			gStopBit = DEFAULT_STOPBIT;
			goto LABEL_STOP_BIT;
	}
	UpdateData(FALSE);
}
//--------------------------------------------------------------------------------
//[֐]Rg[̏Ԃp[^ɔf
//[]Rg[̏ԂΉp[^ɔf܂B
//[]Ȃ
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnControlToValue()
{
	char tmp[32];
	char *e;

	UpdateData(TRUE);

	m_cboCom.GetLBText(m_cboCom.GetCurSel(),gCom);
	GetDlgItemText(IDC_EDIT_ID, tmp, sizeof(tmp));
	gId = (char)strtol(tmp,&e,16);
	m_cboSpeed.GetLBText(m_cboSpeed.GetCurSel(),tmp);
	gBaudrate = (int)atol(tmp);
	switch(m_rdoLength)
	{
		case 0:gByteSize = 8;break;
		case 1:gByteSize = 7;break;
	}
	switch(m_rdoParity)
	{
		case 0:gParity = PARITY_None;break;
		case 1:gParity = PARITY_Odd;break;
		case 2:gParity = PARITY_Even;break;
	}
	switch(m_rdoStop)
	{
		case 0:gStopBit = STOP_Bit1;break;
		case 1:gStopBit = STOP_Bit2;break;
	}
}
//--------------------------------------------------------------------------------
//[֐]Rg[͊mF
//[]ID̓͏Ԃ̊mFs܂
//[]Ȃ
//[ߒl]true:,false:ُ
//--------------------------------------------------------------------------------
bool CSS_232C_RLSW_VC6_SAMPLEDlg::bfnCheckControl()
{
	char tmp[32];
	int id;

	UpdateData(TRUE);
	GetDlgItemText(IDC_EDIT_ID, tmp, sizeof(tmp));
	if(sscanf_s(tmp,"%x",&id) != 1) goto LABEL_ERR_INPUT;
	if(id < 0 || 255 < id) goto LABEL_ERR_INPUT;
	gId = (char)id;
	return true;
LABEL_ERR_INPUT:
	MessageBox("ID:0`FF(Hex)","̓G[",MB_ICONERROR | MB_OK);
	return false;
}
//--------------------------------------------------------------------------------
//[֐]G[bZ[W̕\
//[]DLLG[\܂B
//[]txt		G[eLXg
//		code	G[R[h
//[ߒl]Ȃ
//--------------------------------------------------------------------------------
void CSS_232C_RLSW_VC6_SAMPLEDlg::vfnDllCallError(CString txt,int code)
{
	CString err;
	switch(code)
	{
		case RET_ERR_OPEN:err = "I[vG[";break;
		case RET_ERR_SEND:err = "MG[";break;
		case RET_ERR_READ:err = "MG[";break;
		case RET_ERR_SET_COM_STATE:err = "ʐMݒG[";break;
		case RET_ERR_TIMEOUT:err = "^CAEgG[";break;
		case RET_ERR_NO_DELIMITER:err = "f~^MȂG[";break;
		case RET_ERR_BAUDRATE:err = "ʐMxݒG[";break;
		case RET_ERR_BYTE_SIZE:err = "oCgݒG[";break;
		case RET_ERR_PARITY:err = "peBݒG[";break;
		case RET_ERR_STOP_BITS:err = "XgbvrbgݒG[";break;
		case RET_ERR_RCV_FORMAT:err = "R}htH[}bgG[";break;
		default:err = "";break;
	}
	MessageBox(txt + "\r\n" + err,"Dll call error",MB_ICONERROR | MB_OK);
}