Public Class main
    '--------------------------------------------------------------------------------
    '[萔`]
    '--------------------------------------------------------------------------------
    Private Const INI_FILE = ".\SS_232C_RLSW_sample.ini"        'ݒt@C
    Private Const DEFAULT_COM = "COM1"                          'COM1
    Private Const DEFAULT_ID = &HFF                             'ff
    Private Const DEFAULT_BAUDRATE = 9600                       '9600bps
    Private Const DEFAULT_BYTE_SIZE = 8                         '8bit
    Private Const DEFAULT_PARITY = SS_232C_RLSW.Parity.None     'peB
    Private Const DEFAULT_STOPBIT = SS_232C_RLSW.StopBit.Bit1   '1bit
    '--------------------------------------------------------------------------------
    '[GA`]
    '--------------------------------------------------------------------------------
    Private _isConnect As Boolean = False                       'ڑԋLp
    Private _output As Short = 0                                'ݏoIO
    Private _com As String = DEFAULT_COM                        'COM|[g                                      
    Private _id As Byte = DEFAULT_ID                            'R}hID
    Private _baudrate As UInteger = DEFAULT_BAUDRATE            '{[[g
    Private _byte_size As Byte = DEFAULT_BYTE_SIZE              'oCg
    Private _parity As Byte = DEFAULT_PARITY                    'peB
    Private _stop_bit As Byte = DEFAULT_STOPBIT                 'Xgbvrbg
    '--------------------------------------------------------------------------------
    '[Evnt]tH[[h
    '[] ݒt@Cp[^ǂݍ݊eRg[ɐݒ肵܂B
    '       ǂݍݎs̎͋Klݒ肵܂B
    '--------------------------------------------------------------------------------
    Private Sub main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        vfnReadIniFile()       'ݒt@C̓ǂݍ
        vfnValueToControl()    'p[^Rg[ɔf
        _isConnect = False     'ؒf
        vfnControlsLock(False) 'ؒfԂ̃Rg[ݒ

    End Sub
    '--------------------------------------------------------------------------------
    '[Evnt]tH[A[h
    '[] ڑς݂Ȃؒfs
    '--------------------------------------------------------------------------------
    Private Sub main_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If (_isConnect) Then
            SS_232C_RLSW.SS232CRLSW_close()
        End If

    End Sub
    '--------------------------------------------------------------------------------
    '[Evnt]ڑ/ؒf{^
    '[]COM|[g̐ڑ/ؒfs܂B
    '      ڑAݒݒt@CɋL܂B
    '      ڑAo͏ԂeCh̃{^ɕ\܂B
    '--------------------------------------------------------------------------------
    Private Sub btnOpenClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenClose.Click

        Dim iRet As Integer

        btnOpenClose.Enabled = False
        If btnOpenClose.Text = "Open" Then
            If bfnCheckControl() Then
                vfnControlToValue()                     'p[^XV
                vfnValueToControl()                     'Rg[f
                iRet = SS_232C_RLSW.SS232CRLSW_open(_com, _baudrate, _byte_size, _parity, _stop_bit)
                If iRet <> SS_232C_RLSW.RET_OK Then
                    vfnDllError("SS232CRLSW_open", iRet)
                Else
                    vfnWriteIniFile()                   'p[^ۑ
                    btnOpenClose.Text = "Close"         'Close{^ɕύX
                    vfnControlsLock(True)               'Rg[gpύX
                    vfnReadOutput()                     'eCh̃Xe[^X\ɏo͏Ԃ\
                    vfnReadDeviceInfo()                 'foCX̕\
                    _isConnect = True                   'ڑς
                End If
            End If
        Else
            SS_232C_RLSW.SS232CRLSW_close()             'ؒf
            btnOpenClose.Text = "Open"                  'Open{^ɕύX
            vfnControlsLock(False)                      'Rg[̎gpύX
            _isConnect = False                          'ؒfς
        End If
        btnOpenClose.Enabled = True

    End Sub
    '--------------------------------------------------------------------------------
    '[Evnt]Ch.Set/Reset{^
    '[]eChɏo͐ݒ(ON/OFF)s܂B
    '      ݒo͏ԂQƂ܂B
    '--------------------------------------------------------------------------------
    Private Sub btnChx_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCh8.Click, btnCh7.Click, btnCh6.Click, btnCh5.Click, btnCh4.Click, btnCh3.Click, btnCh2.Click, btnCh1.Click
        Dim sOut As Short
        Dim iRet As Integer
        Dim btn As Button = CType(sender, Button)
        Dim iIndex As Integer = CType(btn.Tag, Integer)

        sOut = (_output Xor (1 << iIndex))

        iRet = SS_232C_RLSW.SS232CRLSW_output_data(_id, sOut)
        If (iRet = SS_232C_RLSW.RET_OK) Then
            vfnReadOutput()  'o͎Q
        Else
            vfnDllError("SS232CRLSW_output_data", iRet)
        End If

    End Sub
    '--------------------------------------------------------------------------------
    '[Evnt]WI{^(7l)
    '[]ږɃIvVrݒs܂B
    '--------------------------------------------------------------------------------
    Private Sub rdoBits8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoBits8.Click
        rdoBits8.Checked = True
        rdoBits7.Checked = False
        _byte_size = 8
    End Sub
    Private Sub rdoBits7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoBits7.Click
        rdoBits8.Checked = False
        rdoBits7.Checked = True
        _byte_size = 7
    End Sub
    Private Sub rdoParityNone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoParityNone.Click
        rdoParityNone.Checked = True
        rdoParityOdd.Checked = False
        rdoParityEven.Checked = False
        _parity = SS_232C_RLSW.Parity.None
    End Sub
    Private Sub rdoParityOdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoParityOdd.Click
        rdoParityNone.Checked = False
        rdoParityOdd.Checked = True
        rdoParityEven.Checked = False
        _parity = SS_232C_RLSW.Parity.Odd
    End Sub
    Private Sub rdoParityEven_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoParityEven.Click
        rdoParityNone.Checked = False
        rdoParityOdd.Checked = False
        rdoParityEven.Checked = True
        _parity = SS_232C_RLSW.Parity.Even
    End Sub
    Private Sub rdoStop1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoStop1.Click
        rdoStop1.Checked = True
        rdoStop2.Checked = False
        _stop_bit = SS_232C_RLSW.StopBit.Bit1
    End Sub
    Private Sub rdoStop2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoStop2.Click
        rdoStop1.Checked = False
        rdoStop2.Checked = True
        _stop_bit = SS_232C_RLSW.StopBit.Bit2
    End Sub
    '--------------------------------------------------------------------------------
    '[֐]foCX̓ǂݍ
    '[]jbgIDƃo[WbZ[W\܂B
    '[]Ȃ
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnReadDeviceInfo()
        Dim id As Byte : id = 0
        Dim version = New System.Text.StringBuilder(0)
        Dim iRet As Integer

        iRet = SS232CRLSW.SS232CRLSW_unit_number(id)
        If iRet <> RET_OK Then
            vfnDllError("SS232CRLSW_unit_number", iRet)
            Exit Sub
        End If
        iRet = SS232CRLSW.SS232CRLSW_get_version_number(_id, version, 0)
        If iRet < 0 Then
            vfnDllError("SS232CRLSW_get_version_number", iRet)
            Exit Sub
        End If
        version = New System.Text.StringBuilder(iRet)
        iRet = SS232CRLSW.SS232CRLSW_get_version_number(_id, version, iRet)
        If iRet < 0 Then
            vfnDllError("SS232CRLSW_get_version_number", iRet)
            Exit Sub
        End If
        MessageBox.Show(String.Format("jbgԍ:[{0:X2}]" + vbCrLf + "{1}", id, version.ToString()), "foCX")

    End Sub
    '--------------------------------------------------------------------------------
    '[֐]Rg[̏Ԑݒ
    '[](ڑ^ؒf)ɍ킹ĎgpoRg[ݒ肵܂B
    '[]connect  true:ڑԁAfalse:ؒf
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnControlsLock(ByVal connect As Boolean)

        'ڑgp\
        btnCh1.Enabled = connect
        btnCh2.Enabled = connect
        btnCh3.Enabled = connect
        btnCh4.Enabled = connect
        btnCh5.Enabled = connect
        btnCh6.Enabled = connect
        btnCh7.Enabled = connect
        btnCh8.Enabled = connect
        lblCh1.Enabled = connect
        lblCh2.Enabled = connect
        lblCh3.Enabled = connect
        lblCh4.Enabled = connect
        lblCh5.Enabled = connect
        lblCh6.Enabled = connect
        lblCh7.Enabled = connect
        lblCh8.Enabled = connect
        btnCh1.Text = ""
        btnCh2.Text = ""
        btnCh3.Text = ""
        btnCh4.Text = ""
        btnCh5.Text = ""
        btnCh6.Text = ""
        btnCh7.Text = ""
        btnCh8.Text = ""
        'ؒfgp\
        grpDevice.Enabled = Not connect
        grpSetting.Enabled = Not connect

    End Sub
    '--------------------------------------------------------------------------------
    '[֐]o͏Ԃ̓ǂݍ
    '[]o͏ԂQƂAeCh̃Xe[^X\ɕ\܂B
    '[]Ȃ
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnReadOutput()
        Dim sOut As Short = 0
        Dim iRet As Integer
        Dim sPtn As Short

        iRet = SS_232C_RLSW.SS232CRLSW_read_output_data(_id, sOut) 'o͏ԎQ
        If (iRet = SS_232C_RLSW.RET_OK) Then
            _output = sOut                                   'o͏ԋL
            'eChXe[^X\ɕ\
            sPtn = &H1
            btnCh1.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H2
            btnCh2.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H4
            btnCh3.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H8
            btnCh4.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H10
            btnCh5.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H20
            btnCh6.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H40
            btnCh7.Text = IIf((_output And sPtn) <> 0, "", "")
            sPtn = &H80
            btnCh8.Text = IIf((_output And sPtn) <> 0, "", "")
        Else
            vfnDllError("SS232CRLSW_read_output_data", iRet)
        End If

    End Sub
    '--------------------------------------------------------------------------------
    '[֐]ݒt@C̓ǂݍ
    '[]ݒt@Cp[^ǂݍ݂܂B
    '      ǂݍݎs̎͋Kl܂B
    '[]Ȃ
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnReadIniFile()
        Dim buf As New System.Text.StringBuilder()
        buf.Capacity = 32
        GetPrivateProfileString("DEVICE", "COM", DEFAULT_COM, buf, 16, INI_FILE)   'ݒt@Cǂݍ
        _com = buf.ToString()
        GetPrivateProfileString("DEVICE", "ID", DEFAULT_ID.ToString(), buf, 16, INI_FILE)   'ݒt@Cǂݍ
        If Not Byte.TryParse(buf.ToString(), _id) Then _id = DEFAULT_ID
        GetPrivateProfileString("SETTING", "BAUDRATE", DEFAULT_BAUDRATE.ToString(), buf, 16, INI_FILE)   'ݒt@Cǂݍ
        If Not UInteger.TryParse(buf.ToString(), _baudrate) Then _baudrate = DEFAULT_BAUDRATE
        GetPrivateProfileString("SETTING", "BYTE_SIZE", DEFAULT_BYTE_SIZE.ToString(), buf, 16, INI_FILE)   'ݒt@Cǂݍ
        If Not Byte.TryParse(buf.ToString(), _byte_size) Then _byte_size = DEFAULT_BYTE_SIZE
        GetPrivateProfileString("SETTING", "PARITY", DEFAULT_PARITY.ToString(), buf, 16, INI_FILE)   'ݒt@Cǂݍ
        If Not Byte.TryParse(buf.ToString(), _parity) Then _parity = DEFAULT_PARITY
        GetPrivateProfileString("SETTING", "STOP_BIT", DEFAULT_STOPBIT.ToString(), buf, 16, INI_FILE)   'ݒt@Cǂݍ
        If Not Byte.TryParse(buf.ToString(), _stop_bit) Then _stop_bit = DEFAULT_STOPBIT
    End Sub
    '--------------------------------------------------------------------------------
    '[֐]ݒt@C̏
    '[]ݒt@CɃp[^݂܂B
    '[]Ȃ
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnWriteIniFile()
        WritePrivateProfileString("DEVICE", "COM", _com, INI_FILE)
        WritePrivateProfileString("DEVICE", "ID", _id.ToString(), INI_FILE)
        WritePrivateProfileString("SETTING", "BAUDRATE", _baudrate.ToString(), INI_FILE)
        WritePrivateProfileString("SETTING", "BYTE_SIZE", _byte_size.ToString(), INI_FILE)
        WritePrivateProfileString("SETTING", "PARITY", _parity.ToString(), INI_FILE)
        WritePrivateProfileString("SETTING", "STOP_BIT", _stop_bit.ToString(), INI_FILE)
    End Sub
    '--------------------------------------------------------------------------------
    '[֐]p[^̏ԂRg[ɔf
    '[]p[^̏ԂΉRg[ɔf
    '[]Ȃ
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnValueToControl()

        cboCom.Text = _com
        txtId.Text = _id.ToString("X2")
        cboSpeed.Text = _baudrate.ToString()
        Select Case (_byte_size)
            Case 8
                rdoBits8.Checked = True
                rdoBits7.Checked = False
            Case 7
                rdoBits8.Checked = False
                rdoBits7.Checked = True
            Case Else
                _byte_size = DEFAULT_BYTE_SIZE
        End Select
        Select Case (_parity)
            Case SS_232C_RLSW.Parity.None
                rdoParityNone.Checked = True
                rdoParityOdd.Checked = False
                rdoParityEven.Checked = False
            Case SS_232C_RLSW.Parity.Odd
                rdoParityNone.Checked = False
                rdoParityOdd.Checked = True
                rdoParityEven.Checked = False
            Case SS_232C_RLSW.Parity.Even
                rdoParityNone.Checked = False
                rdoParityOdd.Checked = False
                rdoParityEven.Checked = True
            Case Else
                _parity = SS_232C_RLSW.Parity.None
        End Select
        Select Case (_stop_bit)
            Case SS_232C_RLSW.StopBit.Bit1
                rdoStop1.Checked = True
                rdoStop2.Checked = False
            Case SS_232C_RLSW.StopBit.Bit2
                rdoStop1.Checked = False
                rdoStop2.Checked = True
            Case Else
                _stop_bit = SS_232C_RLSW.StopBit.Bit1
        End Select

    End Sub
    '--------------------------------------------------------------------------------
    '[֐]Rg[̏Ԃp[^ɔf
    '[]Rg[̏ԂΉp[^ɔf܂B
    '[]Ȃ
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnControlToValue()

        _com = CType(cboCom.SelectedItem, String)
        _id = Convert.ToByte(txtId.Text, 16)
        _baudrate = UInteger.Parse((cboSpeed.SelectedItem))

    End Sub
    '--------------------------------------------------------------------------------
    '[֐]Rg[͊mF
    '[]ID̓͏Ԃ̊mFs܂
    '[]Ȃ
    '[ߒl]true:,false:ُ
    '--------------------------------------------------------------------------------
    Private Function bfnCheckControl() As Boolean

        Try
            Dim b As Byte = Convert.ToByte(txtId.Text, 16)
        Catch
            MessageBox.Show("ID̒lsłB" + vbCrLf + "00`FF", "̓G[", MessageBoxButtons.OK)
            Return False
        End Try
        Return True

    End Function
    '--------------------------------------------------------------------------------
    '[֐]DLLG[\
    '[]DLL̃G[\܂
    '[]txt  G[eLXg
    '           G[R[h
    '[ߒl]Ȃ
    '--------------------------------------------------------------------------------
    Private Sub vfnDllError(ByVal txt As String, ByVal code As Long)

        Dim err As String

        Select Case (code)
            Case RET_ERR_OPEN : err = "I[vG["
            Case RET_ERR_SEND : err = "MG["
            Case RET_ERR_READ : err = "MG["
            Case RET_ERR_SET_COM_STATE : err = "ʐMݒG["
            Case RET_ERR_TIMEOUT : err = "^CAEgG["
            Case RET_ERR_NO_DELIMITER : err = "f~^MȂG["
            Case RET_ERR_BAUDRATE : err = "ʐMxݒG["
            Case RET_ERR_BYTE_SIZE : err = "oCgݒG["
            Case RET_ERR_PARITY : err = "peBݒG["
            Case RET_ERR_STOP_BITS : err = "XgbvrbgݒG["
            Case RET_ERR_RCV_FORMAT : err = "tH[}bgG["
            Case Else : err = ""
        End Select

        MessageBox.Show(txt + vbCrLf + err, "Dll call error", MessageBoxButtons.OK, MessageBoxIcon.Error)

    End Sub
End Class
